/* Program comptast.cc  */
/* By Harald Stauss     */
/* Last change 26.08.98 */


#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>
#include "tsa.h"

main(int argc, char *argv[])
{
  short    i,chn; 
  unsigned long     n;
  char     *fin1,*fout,*ftin1,*ftout;
  char     *pfin1, *pfout, *pftin1, *pftout;
  REGIST   r1,r2;


  /* H e l l o   w o r l d */
  cout << "COMPTAST Ver.1.1 by H. Stauss, 1998 \n";

  /* A r r a y s   a l l o c i e r e n */
  fin1=(char *)malloc(255); pfin1=fin1;
  fout=(char *)malloc(255); pfout=fout;
  ftin1=(char *)malloc(255); pftin1=ftin1;
  ftout=(char *)malloc(255); pftout=ftout;

  /* P a r a m e t e r   e i n l e s e n */
  if (argc != 4)
    {
      cout << "Number of parameters wrong! \n";
      cout << "comptast f_in1 f_out chn \n";
      cout << "combines channel chn and (chn+1) \n";
      cout << "f_in1 : name of input file 1 (*.TSA, *.ASC). \n";
      cout << "f_out : name of output file (*.TSA, *.ASC). \n";
      cout << "chn   : channel to be summed (starts with 1). \n";
     goto ende;
    }
  strcpy(fin1,argv[1]);
  strcpy(fout,argv[2]);
  strcpy(ftin1,fin1);
  strcpy(ftout,fout);
  pftin1=strrchr(ftin1,'.');

  for (i=0; pftin1[i]; i++) pftin1[i]=toupper(pftin1[i]);
  pftout=strrchr(ftout,'.');
  for (i=0; pftout[i]; i++) pftout[i]=toupper(pftout[i]);
  
  chn=atoi(argv[3]); chn--;
  
  printf("Input file  : %s \n",fin1);
  printf("Output file : %s \n",fout);
  printf("Channel     : %d \n",chn);

  /* E i n g a b e d a t e i   o e f f n e n */
  if (strcmp(pftin1,".TSA")==0) r1.ReadTSA(fin1);
  if (strcmp(pftin1,".ASC")==0) r1.ReadASCII(fin1,1);
  if ((strcmp(pftin1,".TSA")!=0) && (strcmp(pftin1,".ASC")!=0)) {
    cout << "File type for input file not recognized! \n";
    goto ende;
  }
  printf("Number of channels in input file: %d  \n",r1.n);
  
  for (i=0; i<r1.n-1; i++) {
              r2.AddChannel(r1.ch[i].n, r1.ch[i].sr,
			    r1.ch[i].min, r1.ch[i].max,
			    r1.ch[i].res, r1.ch[i].name,
			    r1.ch[i].unit);
  }

  /* c o p y   i n p u t   f i l e   i n   o u t p u t   f i l e   */
  for (i=0; i<r1.n; i++) {
    if (i!=chn && i!=chn+1) {
      for (n=0; n<r1.ch[i].n; n++) {
        if (i<chn)     r2.ch[i].data[n]=r1.ch[i].data[n];
	if (i>(chn+1)) r2.ch[i-1].data[n]=r1.ch[i].data[n];
      }
    }
  }


  /* M A I N L O O P  */
  cout << "n in channel " << chn << ": " << r1.ch[chn].n << "\n";
  for (n=0; n<r1.ch[chn].n; n++) {
    if ((r1.ch[chn].data[n]>60) || (r1.ch[chn+1].data[n]>60)) {
	r2.ch[chn].data[n]=100;
    }
    else
      r2.ch[chn].data[n]=0;
  } /* Endfor */

  /* D a t e i   s c h r e i b e n */
  if (strcmp(pftout,".TSA")==0) r2.WriteTSA(fout);
  if (strcmp(pftout,".ASC")==0) r2.WriteASCII(fout);
  if ((strcmp(pftout,".TSA")!=0) && (strcmp(pftout,".ASC")!=0)) {
    printf("File type for output not recognized! \n");
    goto ende;
  }

 ende:
  free(fin1);free(ftin1); free(fout);free(ftout);
  return(0);
} /* Ende von main */


